@file:JvmName("_MapResultSetKt")
package ru.landgrafhomyak.db.jdbc_kotlin_extensions

import java.sql.ResultSet
import ru.landgrafhomyak.utility.highlevel_try_finally.safeAutoClose1


public inline fun <R, C : MutableCollection<R>> ResultSet.mapTo(to: C, transform: (rs: ResultSet) -> R): C {
	while (this.next()) {
		to.add(transform(this))
	}
	return to
}

public inline fun <R> ResultSet.map(transform: (rs: ResultSet) -> R): List<R> =
	this.mapTo(ArrayList(), transform)

public inline fun <R, C : MutableCollection<R>> ResultSet.mapToThenClose(to: C, transform: (rs: ResultSet) -> R): C =
	safeAutoClose1(finally = this::close) { this.mapTo(to, transform) }

public inline fun <R> ResultSet.mapThenClose(transform: (rs: ResultSet) -> R): List<R> =
	safeAutoClose1(finally = this::close) { this.map(transform) }
